/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 11/12/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import  java.util.List;
import  java.util.Map;
import  org.springframework.cache.annotation.Cacheable;
import  org.springframework.data.domain.Page;
import  org.springframework.data.domain.Pageable;
import  org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import  org.springframework.data.jpa.repository.Query;
import  org.springframework.data.repository.query.Param;
import  org.springframework.stereotype.Repository;

import com.portofolio.entity.MapGolonganPegawaiToPangkat;
import com.portofolio.entity.vo.MapGolonganPegawaiToPangkatId;


public interface MapGolonganPegawaiToPangkatDao extends JpaRepository<MapGolonganPegawaiToPangkat, MapGolonganPegawaiToPangkatId> {

    @Cacheable("MapGolonganPegawaiToPangkatDaofindOneBy")
    MapGolonganPegawaiToPangkat findOneByIdKdGolonganPegawaiAndIdKdPangkatAndIdKdProfileAndKdDepartemen(Integer kdGolonganPegawai, Integer kdPangkat, Integer kdProfile, String KdDepartemen);
    

    @Query(QListAll)
    @Cacheable("MapGolonganPegawaiToPangkatDaoFindAllList")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and golonganPegawai.namaGolonganPegawai like %:namaGolonganPegawai% ")
    @Cacheable("MapGolonganPegawaiToPangkatDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaGolonganPegawai") String namaGolonganPegawai, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.id.kdGolonganPegawai = :kdGolonganPegawai")
    @Cacheable("MapGolonganPegawaiToPangkatDaoFindByKode")
    List<Map<String, Object>> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kdGolonganPegawai") Integer kdGolonganPegawai, @Param("kdDepartemen") String kdDepartemen);
    
    @Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update MapGolonganPegawaiToPangkat m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdGolonganPegawai =:kdGolonganPegawai")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile, @Param("kdGolonganPegawai") Integer kdGolonganPegawai);

	@Cacheable("countMapJabatanToPangkat")
	Long countIdKdGolonganPegawaiByIdKdGolonganPegawaiAndIdKdProfile(Integer kdGolonganPegawai, Integer kdProfile);
    
    String QListAll ="select new map(model.id.kdProfile as kdProfile "
    		+ ", model.id.kdGolonganPegawai as kdGolonganPegawai "
    		+ ", golonganPegawai.namaGolonganPegawai as namaGolonganPegawai "
    		+ ", model.id.kdPangkat as kdPangkat "
    		+ ", pangkat.namaPangkat as namaPangkat "
            + ", model.kdDepartemen as kdDepartemen " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", departemen.namaDepartemen as namaDepartemen, model.version as version )" 
            + " from MapGolonganPegawaiToPangkat model left join model.id id "
            + " left join model.golonganPegawai golonganPegawai "
            + " left join model.pangkat pangkat "
            + " left join model.departemen departemen left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen and model.statusEnabled=true "; 

}
